      SUBROUTINE  COMBNM ( N,M, IFLAG, ISTATE )
C
C              COMBINATION GENERATOR
C
C              N INDEX'S 1,2,3... N TAKEN M AT A TIME
C
C    INPUT:
C              N         I*4       NUMBER OF DISTINCT ITEMS
C              M         I*4       NUMBER TO CHOOSE
C                                  N .GE. M OR NOTHING TO DO
C     INPUT/OUTPUT:
C
C              IFLAG     I*4       1 TO INIT, ELSE ROUTINE SETS
C                                  0  ONGOING OUTPUT
C                                 -1  DONE
C                                 -2  ERROR
C
C              ISTATE(M) I*4       VECTOR OF OUTPUT INDEX'S
C                                  FIRST IS 1,2,3... M
C                                  LAST  IS (N-M+1),...N 
C                                  *  TREAT AS INDEX SET FOR COMPLEX
C                                     USES
C
C         * NOTE BENE *  IF DON'T INIT CAN CAUSE PROBLEMS/MATH ERRORS
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION     ISTATE(1)
C
C         ------------------------------------------------
C
C
      IEND = 0
      IERR = 1
C
C
C         CHECK FOR ERROR CONDITIONS
C
      IF ( N.LE.0 ) GOTO 900
      IF ( M.GT.N ) GOTO 900
C
      IF ( IFLAG.LT.0 ) GOTO 900
      IERR = 0
C
      IF ( IFLAG.GT.0 ) THEN
        DO  100  ISET = 1, M
           ISTATE(ISET) = ISET
100     CONTINUE
        GOTO 900
      ENDIF
C
C              ---  NOW INCREMENT THE STATE ---
C
C              VAL(I) .LT. VAL(I+1)   ALL CASES -- SIMULATE
C                                     NESTED DO'S WITH LOWER LIMIT
C                                     NEXT OUTER VALUE+1, MAX=N
C
C
      IXPLUS  = M
      LIMIT   = N
C
200   CONTINUE
C
C           INCREMENT STATE IF CAN
C
      INOW = ISTATE ( IXPLUS )
C
      IF ( INOW.LT.LIMIT ) THEN
          ISTATE ( IXPLUS ) = INOW + 1
          GOTO 400
      ENDIF
C
C              CAN'T  BACK ONE LEVEL -- IF CAN
C
      IXPLUS = IXPLUS - 1
      LIMIT  = LIMIT  - 1
C
C              CHECK OVERALL END
C
      IF ( IXPLUS.LT.1 ) THEN
         IEND =  -1
         GOTO 900
      ENDIF
      GOTO 200
C
C         SET ONE NEW VALUE  RESET ALL LATER INITS IF ANY
C
400   CONTINUE
C
      IF ( IXPLUS .EQ. M ) GOTO 900
C
      ISETB  = IXPLUS + 1
      DO  500 ISET = ISETB, M
C
         ISTATE ( ISET ) =  ISTATE ( ISET-1 )   + 1
C
500   CONTINUE
C
      GOTO 900
C
C         EXIT SET FLAGS
C
900   CONTINUE
C
      IFG  = IEND
      IF ( IERR.NE.0 ) IFG = -2
C
      IFLAG  = IFG
C
      RETURN
      END
