$TITLE:'CONSTANTS SETTING ROUTINES'
      SUBROUTINE CONSET
C
C      MODIFICATIONS:
C        JRC 7-89    MADE CALLABLE ROUTINE OUT OF BLOCKDATA
C
$INCLUDE:'WRDSIZ.INC'
C
$INCLUDE:'CONSET.INC'
C
C    REARTH COMMON
C
      COMMON /EARTHR/ A , ESS
C
C
C  --- BEST MATH SETS FOR CONSTANTS ---
C
      PI        =   3.14159 26535 898D00
      TPI       =   6.28318 53071 796D0 
      DTR       =   1.7453 292519943D-2
      RTD       =  57.29577 951308 2 D0 
      SQRTPI    =   1.77245 39       D00 
      ELOGS     =   2.71828 18284 590D00 
      SQRT2     =   1.41421 35623 731D00 
      SQRT10    =   3.16227766D0         
C
C    FILL WITH WGS84 VALUES INITIALLY ON GEODETIC/GEOPHYSICAL
C
      RE      =   6378.137      D00 
      FETH    =   0.335 28106 6474 D-2 
      EETH    =   8.181 91908 426  D-2 
      ESETH   =   6.694 37999 013  D-3 
C
      CMPS    =   2.99792 458   D08 
      CKMPS   =   2.99792 458   D05 
      WE      =   7.29211 51467 D-5 
      GMMKS   =   3.98600 5     D14 
      GMKMKS   =  3.98600 5     D05 
C
C     REARTH COMMON VALUES
C
       A       =   6378.137     D0    
       ESS     =   6.694 37999 013  D-3 
C
C
      END
$PAGE
      SUBROUTINE WGS84
C
C     FILL CONSTANTS ARRAYS WITH WGS 84 VALUES
C
$INCLUDE:'WRDSIZ.INC'
$INCLUDE:'CONSET.INC'
C
C     WGS84 VALUES INITIALLY ON GEODETIC/GEOPHYSICAL
C
      COMMON /EARTHR/ A , ESS
C
      DATA RE4  / 6378.137      D00 /
      DATA FETH4 / 0.335 28106 6474 D-2 /
      DATA EETH4 / 8.181 91908 426  D-2 /
      DATA ESETH4/ 6.694 37999 013  D-3 /
C
      DATA CMPS4 / 2.99792 458   D08 /
      DATA CKMPS4/ 2.99792 458   D05 /
      DATA WE4   / 7.29211 51467 D-5 /
      DATA GMMKS4/ 3.98600 5     D14 /
      DATA GMKMK4/ 3.98600 5     D05 /
C
C       CALL CONSET TO ENSURE BACKGROUND NUMBERS INSTALLED
C
      CALL CONSET
C
C
C    SET GEOCON VALUES UP
C
      RE     =  RE4
      FETH   =  FETH4
      EETH   =  EETH4
      ESETH  =  ESETH4
      CMPS   =  CMPS4
      CKMPS  =  CKMPS4
      WE     =  WE4
      GMMKS  =  GMMKS4
      GMKMKS =  GMKMK4
C
C     REARTH COMMON
C
      A      =  RE
      ESS    =  ESETH
C
      RETURN
      END
$PAGE
      SUBROUTINE WGS72
C
C
C     FILL CONSTANTS ARRAYS WITH WGS 72 VALUES
C
$INCLUDE:'WRDSIZ.INC'
$INCLUDE:'CONSET.INC'
C
C     WGS82 VALUES INITIALLY ON GEODETIC/GEOPHYSICAL
C
      COMMON /EARTHR/ A , ESS
C
      DATA RE2  / 6378.135      D00 /
      DATA FETH2 / 0.335 28106 6474 D-2 /
      DATA EETH2 / 8.181 88106 0    D-2 /
      DATA ESETH2/ 6.694 31777 8    D-3 /
C
      DATA CMPS2 / 2.99792 458   D08 /
      DATA CKMPS2/ 2.99792 458   D05 /
      DATA WE2   / 7.29211 51467 D-5 /
      DATA GMMKS2/ 3.98600 8     D14 /
      DATA GMKMK2/ 3.98600 8     D05 /
C
C       CALL CONSET TO ENSURE BACKGROUND NUMBERS INSTALLED
C
      CALL CONSET
C
C
C    SET GEOCON VALUES UP
C
      RE     =  RE2
      FETH   =  FETH2
      EETH   =  EETH2
      ESETH  =  ESETH2
      CMPS   =  CMPS2
      CKMPS  =  CKMPS2
      WE     =  WE2
      GMMKS  =  GMMKS2
      GMKMKS =  GMKMK2
C
C     REARTH COMMON
C
      A      =  RE
      ESS    =  ESETH
C
      RETURN
      END
$PAGE
      SUBROUTINE EELLIP ( FLATEN, SEMAJ )
C
C            RESET EARTH CONSTANT COMMONS WITH
C            NEW EARTH ELLIPSE
C
C    INPUT:
C            FLATEN     R*8      F  ( 1/F ABOUT 298 )
C            SEMAJ      R*8      SEMI MAJOR AXIS IN KM
C
C
C    MODHIST
C         7-97    ERROR IN COMPUTING E**2,   1.0 VS 2.0 CONSTANT
C                 ONLY INTERNAL USE, AND GEOSITES RESET A,F COMMAND
C
C
$INCLUDE:'WRDSIZ.INC'
$INCLUDE:'CONSET.INC'
C
      COMMON /EARTHR/ A , ESS
C
C         --------------------------------------------------------
C
      IF ( ABS(PI - 3.14159D0) .GT. 0.001)  CALL CONSET
C
      IF ( SEMAJ.LE.0.0D0 ) GOTO 900
      IF ( FLATEN.GT.1.0D0 ) GOTO 900
C
      RE    =  SEMAJ
      FETH  =  FLATEN
      ESETH =  2.0D0 * FLATEN - FLATEN**2
      EETH  =  DSQRT ( ABS(ESETH) )
C
C     REARTH COMMON
C
      A      =  RE
      ESS    =  ESETH
C
900   CONTINUE
C
      RETURN
      END
$PAGE
      SUBROUTINE SETELP ( SEMAJ, FLATEN )
C
C            RESET EARTH CONSTANT COMMONS WITH
C            NEW EARTH ELLIPSE
C
C    INPUT:
C            SEMAJ      R*8      SEMI MAJOR AXIS IN KM
C            FLATEN     R*8      F  ( 1/F ABOUT 298 )
C
C
C    MODHIST
C         7-97    ERROR IN COMPUTING E**2,   1.0 VS 2.0 CONSTANT
C                 ONLY INTERNAL USE, AND GEOSITES RESET A,F COMMAND
C                 ***  NEW VERSION WITH INVERTED ARGUMENTS 
C                      AND NEW NAME  ***
C
C
$INCLUDE:'WRDSIZ.INC'
$INCLUDE:'CONSET.INC'
C
      COMMON /EARTHR/ A , ESS
C
C    ---------------------------------------------------------------
C
      IF ( ABS(PI - 3.14159D0) .GT. 0.001)  CALL CONSET
C
      IF ( SEMAJ.LE.0.0D0 ) GOTO 900
      IF ( FLATEN.GT.1.0D0 ) GOTO 900
C
      RE    =  SEMAJ
      FETH  =  FLATEN
      ESETH =  2.0D0 * FLATEN - FLATEN**2
      EETH  =  DSQRT ( ABS(ESETH) )
C
C     REARTH COMMON
C
      A      =  RE
      ESS    =  ESETH
C
900   CONTINUE
C
      RETURN
      END
$PAGE
      SUBROUTINE GETELP ( A,B,F,ES )
C
C         GET THE CURRENT VALUES OF ELLIPSOID USING
C
C    INPUT:
C              NONE -- BUT MUST HAVE DONE A CONSET, OR WILL
C                      DO ONE FOR YOU AND GET DEFAULT SETTINGS
C
C    OUTPUT:
C              A    R*8       SEMI-MAJOR AXIS
C              B    R*8       SEMI-MINOR AXIS
C              F    R*8       FLATTENING
C              ES   R*8       ECC**2,  SQUARE OF ECCENTRICITY
C
C    MODHIST
C         7-14-97   JRC
C
$INCLUDE:'WRDSIZ.INC'
$INCLUDE:'CONSET.INC'
C
C    --------------------------------------------------
C
C              CK ON SOME CALL TO SET CONSTANTS DONE
C                 SET TO DEFAULTS IF NONE DONE
C
C
      IF ( ABS ( PI-3.14159D0 ) .GT.0.001D0 ) CALL CONSET
C
C              -----------------------------
C
      A     =  RE
      ES    =  ESETH
      F     =  FETH
C
      B = 0.0D0
      IF ( ES.LT.1.0D0 ) THEN
         B     =  A * SQRT ( 1.0D0 - ES )
      ENDIF
C
      RETURN
      END
