$TITLE:'DATE AND TIME CONVERSION ROUTINES'
      SUBROUTINE DAYEAR(MONTH,IDAY,JYEAR,DAYNO)
C
C       INTEGER MONTH, DAY, AND YEAR TO F.P. DAY NUMBER OF YEAR
C
C
C          THIS SUBROUTINE CALCULATES THE NUMBER OF A GIVEN DAY OF 
C       THE YEAR.  MONTH IS A SINGLE OR DOUBLE INTEGER DIGIT REPRE- 
C       SENTATION OF THE MONTH.  JYEAR IS 4 OR 2 DIGITS.
C       DAYNO IS THE RETURNED DAY OF THE YEAR EXPRESSED IN FLOATING 
C       POINT FORM.  SPECIAL PROVISION FOR CENTESIMAL LEAP YEARS
C       ( EG. 2000) IS PROVIDED. 
C
C       INPUT:  
C           NAME         TYPE       DIM       MEANING/USE
C           ----         ----       ---       -----------
C           MONTH        I*4         1        MONTH NUMBER(1-12)
C
C           IDAY         I*4         1        DAY OF MONTH
C
C           JYEAR        I*4         1        YEAR IN 2 OR 4 DIGIT FORM
C                                             ( E.G. 88  OR  1988 )
C                                                           
C       OUTPUT:
C           NAME         TYPE       DIM       MEANING/USE
C           ----         ----       ---       -----------
C           DAYNO        REAL*8      1        DAY NUMBER OF YEAR        
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION KDAYS(12) 
C
      DATA KDAYS/0,31,59,90,120,151,181,212,243,273,304,334/
C
C 
      IYEAR = JYEAR
      IF ( IYEAR.LT. 50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
      LEAP=0
      IF(MOD(IYEAR,4).EQ.0)LEAP=1 
C
C     TEST FOR CENTESIMAL LEAP YEAR 
C
      IF(MOD(IYEAR,100).EQ.0.AND.MOD(IYEAR,400).NE.0)LEAP=0 
      IF(MONTH.LE.2)LEAP=0
C
      DAYNO=KDAYS(MONTH)+IDAY+LEAP
      RETURN
      END
$PAGE
      SUBROUTINE AMDY (MONTH,IDAY,JYEAR,DAYNO)
C 
C     RETURNS AN INTEGER REPRESENTATION OF MONTH & DAY
C     GIVEN THE DAY OF YEAR(F.P.) AND YEAR(INTEGER) 
C 
C     THIS SUBROUTINE CALCULATES THE MONTH OF THE YEAR AND 
C     DAY OF THE MONTH. THESE ARE RETURNED IN INTEGER FORM.
C     THE INPUT TO AMDY IS THE YEAR AND DAY OF THE YEAR, IN
C     INTEGER AND FLOATING POINT FORM, RESPECTIVELY.  THE 
C     YEAR INPUT MAY BE IN 2 OR 4 DIGIT FORM.
C
C     INPUT
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        JYEAR          I*4        1       YEAR NUMBER IN 2 OR 4 DIGIT FORM
C
C        DAYNO          REAL*8     1       DAY NUMBER OF THE YEAR
C
C     OUTPUT
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        MONTH          I*4        1       MONTH OF THE YEAR(1-12)
C        
C        IDAY           I*4        1       DAY OF THE MONTH
C
C         
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION KDAYS(12) 
C
           DATA KDAYS/0,31,59,90,120,151,181,212,243,273,304,334/
C
C 
      IYEAR = JYEAR
      IF ( IYEAR.LT. 50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
C 
      M=MONTH 
      LDAY=DAYNO
C
      LEAP=0
      IF(MOD(IYEAR,4).EQ.0)LEAP=1 
C
C     TEST FOR CENTESIMAL LEAP YEAR 
C
      IF(MOD(IYEAR,100).EQ.0.AND.MOD(IYEAR,400).NE.0)LEAP=0 
      IF(LDAY.LE.59)LEAP=0
      IF(LDAY.GT.(365+LEAP).OR.LDAY.LE.0)GO TO 200 
C
      DO 100  IM=2,12
         M = IM 
         IF ( (KDAYS(M)+LEAP) .GE. LDAY ) GO TO 150
 100  CONTINUE
C
      M=13
150   CONTINUE
C
      M=M-1 
C
      IF(LDAY.EQ.60)LEAP=0
      IDAY=LDAY-(KDAYS(M)+LEAP) 
      MONTH=M 
      RETURN
C
200   CONTINUE
C
      MONTH=0 
      IDAY=0
      RETURN
      END 
$PAGE
      SUBROUTINE MDYDOY ( MONTH,IDAY,JYEAR,IDOY )
C
C       INTEGER MONTH, DAY, AND YEAR TO INT  DAY NUMBER OF YEAR
C
C
C          THIS SUBROUTINE CALCULATES THE NUMBER OF A GIVEN DAY OF 
C       THE YEAR.  MONTH IS A SINGLE OR DOUBLE INTEGER DIGIT REPRE- 
C       SENTATION OF THE MONTH.  JYEAR IS 4 OR 2 DIGITS.
C       DAYNO IS THE RETURNED DAY OF THE YEAR EXPRESSED IN FLOATING 
C       POINT FORM.  SPECIAL PROVISION FOR CENTESIMAL LEAP YEARS
C       ( EG. 2000) IS PROVIDED. 
C
C       INPUT:  
C           NAME         TYPE       DIM       MEANING/USE
C           ----         ----       ---       -----------
C           MONTH        I*4         1        MONTH NUMBER(1-12)
C
C           IDAY         I*4         1        DAY OF MONTH
C
C           JYEAR        I*4         1        YEAR IN 2 OR 4 DIGIT FORM
C                                             ( E.G. 88  OR  1988 )
C                                                           
C       OUTPUT:
C           NAME         TYPE       DIM       MEANING/USE
C           ----         ----       ---       -----------
C           IDOY         I*4         1        DAY NUMBER OF YEAR        
C
C
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION KDAYS(12) 
C
      DATA KDAYS/0,31,59,90,120,151,181,212,243,273,304,334/
C
C 
      IYEAR = JYEAR
      IF ( IYEAR.LT. 50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
      LEAP=0
      IF(MOD(IYEAR,4).EQ.0)LEAP=1 
C
C     TEST FOR CENTESIMAL LEAP YEAR 
C
      IF( MOD(IYEAR,100).EQ.0 .AND. MOD(IYEAR,400).NE.0 ) LEAP=0 
      IF( MONTH.LE.2 )  LEAP=0
C
      IDOY =  KDAYS(MONTH) + IDAY + LEAP
      RETURN
      END
$PAGE
      SUBROUTINE DOYMDY  ( JYEAR,IDOY,MONTH,IDAY )
C 
C     RETURNS AN INTEGER REPRESENTATION OF MONTH & DAY
C     GIVEN THE DAY OF YEAR  AND YEAR
C
C         ALL INT. FORM AND ORDER IN,OUT
C
C 
C     THIS SUBROUTINE CALCULATES THE MONTH OF THE YEAR AND 
C     DAY OF THE MONTH. THESE ARE RETURNED IN INTEGER FORM.
C     THE INPUT IS THE YEAR AND DAY OF THE YEAR, IN
C     INTEGER AND FLOATING POINT FORM, RESPECTIVELY.  THE 
C     YEAR INPUT MAY BE IN 2 OR 4 DIGIT FORM.
C
C     INPUT
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        JYEAR          I*4        1       YEAR NUMBER IN 2 OR 4 DIGIT FORM
C
C        IDOY           I*4        1       DAY NUMBER OF THE YEAR
C
C     OUTPUT
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        MONTH          I*4        1       MONTH OF THE YEAR(1-12)
C        
C        IDAY           I*4        1       DAY OF THE MONTH
C
C         
$INCLUDE:'WRDSIZ.INC'
C
      DIMENSION KDAYS(12) 
C
           DATA KDAYS/0,31,59,90,120,151,181,212,243,273,304,334/
C
C 
      IYEAR = JYEAR
      IF ( IYEAR.LT. 50 ) IYEAR = IYEAR + 2000
      IF ( IYEAR.LT.100 ) IYEAR = IYEAR + 1900
C
C 
      M    = MONTH 
      LDAY = IDOY 
C
      LEAP = 0
      IF( MOD(IYEAR,4) .EQ. 0 )  LEAP=1 
C
C     TEST FOR CENTESIMAL LEAP YEAR 
C
      IF( MOD(IYEAR,100).EQ.0 .AND. MOD(IYEAR,400).NE.0 )  LEAP=0 
      IF( LDAY.LE.59 )  LEAP=0
      IF( LDAY.GT.(365+LEAP) .OR. LDAY.LE.0 ) GO TO 200 
C
      DO 100  IM=2,12 
         M = IM
         IF ( (KDAYS(M)+LEAP) .GE. LDAY ) GO TO 150
 100  CONTINUE
C
      M   =  13
150   CONTINUE
C
      M   =  M - 1 
C
      IF( LDAY.EQ.60 )  LEAP=0
      IDAY  =  LDAY - ( KDAYS(M) + LEAP ) 
      MONTH =  M 
      RETURN
C
200   CONTINUE
C
      MONTH  = 0 
      IDAY   = 0
      RETURN
      END 
$PAGE
$SUBTITLE:'GPS DATE/TIME'
      SUBROUTINE IWNTDOY(IWN,IYEAR,IDOY)
C
C     INTEGER FORM OF GPS WEEK TO YEAR AND DAY OF YEAR
C     ( RETURNS THE SUMDAY )
C
C          THIS ROUTINE RETURNS INTEGER FORMS OF THE YEAR
C     AND DAY OF THE YEAR.  THE INPUT IS THE GPS WEEK NUMBER
C     IN INTEGER FORM.  GPS WEEK 0 STARTED ON 1/6/1980.
C
C     INPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        IWN            I*4        1       GPS WEEK NUMBER
C
C     OUTPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        IYEAR          I*4        1       YEAR (4-DIGIT FORM)
C
C        IDOY           I*4        1       DAY NUMBER OF YEAR
C         
C         
$INCLUDE:'WRDSIZ.INC'
C
C
C
      NWEEK    =    IWN
      IDAYS    =    6+7*NWEEK
C
C       COUNT LEAP CYCLES ( 4*365+1 DAYS ) SINCE FEB 29, 1980
C       TO GET YEARS. 2000 IS A LEAP YEAR, SO WORKS. 
C       FOR DAY OF YEAR,  NEED THE NUMBER IN PREVIOUS YEARS
C       DON'T HAVE TO DEAL WITH FAR PAST -- IS GPS UTILITY
C
C         LEAP DAYS SINCE BEGINNING OF GPS TIME
C
      NDAYLP   =    IDAYS - 60
      NLEAP    =    1 + NDAYLP/1461
C
      NYR      =    (IDAYS - NLEAP - 1 )/365
      IDOY     =    IDAYS - NYR*365 - NLEAP
C
C         TOOK OUT 1 TOO FEW DAYS DURING LEAP YEAR - PRIOR 2/29
C
      IF (MOD(NYR,4) .EQ.0 ) THEN
           IDOY  =  IDOY + 1
           LEAPR =  IDAYS - (NLEAP - 1)*1461
           IF ( LEAPR.GT.366) IDOY = IDOY - 1
      ENDIF
C           
C
      IYEAR    =    1980  + NYR
C
      RETURN
      END 
$PAGE
      SUBROUTINE WNTDOY(WN,YEAR,DOY)
C
C    F.P. FORM OF GPS WEEK TO YEAR AND DAY OF YEAR
C    ( RETURNS THE SUMDAY )
C
C         THIS ROUTINE RETURNS FLOATING POINTS FORMS OF THE
C    YEAR AND DAY OF YEAR.  INPUT TO WNTDOY CONSISTS OF THE
C    GPS WEEK NUMBER IN FLOATING POINT FORM.
C
C    INPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        WN             REAL*8     1       GPS WEEK NUMBER
C
C    OUTPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        YEAR           REAL*8     1       YEAR NUMBER (4-DIGIT FORM)
C 
C        DOY            REAL*8     1       DAY NUMBER OF YEAR
C
C
$INCLUDE:'WRDSIZ.INC'
C
C
C
      NWEEK    =    WN
      IDAYS    =    6+7*NWEEK
C
C       COUNT LEAP CYCLES ( 4*365+1 DAYS ) SINCE FEB 29, 1980
C       TO GET YEARS. 2000 IS A LEAP YEAR, SO WORKS. 
C       FOR DAY OF YEAR,  NEED THE NUMBER IN PREVIOUS YEARS
C       DON'T HAVE TO DEAL WITH FAR PAST -- IS GPS UTILITY
C
C         LEAP DAYS SINCE BEGINNING OF GPS TIME
C
      NDAYLP   =    IDAYS - 60
      NLEAP    =    1 + NDAYLP/1461
C
      NYR      =    (IDAYS - NLEAP - 1 )/365
      IDOY     =    IDAYS - NYR*365 - NLEAP
C
C         TOOK OUT 1 TOO FEW DAYS DURING LEAP YEAR - PRIOR 2/29
C
      IF (MOD(NYR,4) .EQ.0 ) THEN
           IDOY  =  IDOY + 1
           LEAPR =  IDAYS - (NLEAP - 1)*1461
           IF ( LEAPR.GT.366) IDOY = IDOY - 1
      ENDIF
C           
C
      IYEAR    =    1980  + NYR
C
      DOY  =  IDOY
      YEAR =  IYEAR
C
      RETURN
      END 
$PAGE
      SUBROUTINE SWTDHMS  ( ISECWK, IDAYWK, IHRDAY, IMINDAY, ISECDAY )
C 
C        SWTDHMS CONVERTS SECONDS OF WEEK TO DAY OF WEEK AND HOURS, MINUTES,
C        SECONDS OF DAY.  ALL INPUT AND OUTPUT PARAMETERS ARE INTEGERS.
C 
C             THIS ROUTINE RETURNS INTEGER FORMS OF THE DAY OF THE WEEK, AND
C        HOUR, MINUTE, SECOND OF THE DAY.  THE INPUT TO SWTDHMS IS THE INTEGER
C        FORM OF THE SECOND OF THE WEEK.  THIS ROUTINE CALLS THE ROUTINE     
C        SECTHMS, WHICH CONVERTS SECOND OF DAY TO HOUR, MINUTE OF HOUR, AND
C        SECOND OF MINUTE.
C
C     INPUT
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        ISECWK         I*4        1       SECOND OF WEEK 
C         
C     OUTPUT 
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        IDAYWK         I*4        1       DAY OF WEEK 
C
C        IHRDAY         I*4        1       HOUR OF DAY
C
C        IMINDAY        I*4        1       MINUTES OF HOUR
C
C        ISECDAY        I*4        1       SECONDS OF MINUTE
C 
C  04/26/84  JLW
C 
$INCLUDE:'WRDSIZ.INC'
C 
      IDAYWK =  ISECWK / 86400
      XSECDAY = ISECWK - IDAYWK * 86400.
C
      CALL SECTHMS  ( XSECDAY, IHRDAY, IMINDAY, ISECDAY ) 
C
      RETURN
      END
$PAGE
      SUBROUTINE DHMSTSW (ISECWK, IDAYWK, IHRDAY, IMINDAY, ISECDAY)
C 
C   DHMSTSW CONVERTS DAY OF WEEK AND HOURS, MINUTES, SECONDS OF DAY TO 
C   SECONDS OF WEEK.  ALL INPUT AND OUTPUT PARAMETERS ARE INTEGERS. 
C 
C        THIS ROUTINE RETURNS INTEGER FORMS OF THE DAY OF THE WEEK,
C   AND HOUR,MINUTE,SECOND OF DAY.  THE INPUT IS THE INTEGER FORM OF
C   THE SECOND OF THE WEEK.  DHMSTSW CALLS THE ROUTINE HMSTSEC, WHICH
C   CONVERTS HOUR,MINUTE,SEC OF DAY TO SECOND OF DAY.
C
C     INPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        IDAYWK         I*4        1       DAY OF WEEK(0=SUN, 6=SAT)
C
C        IHRDAY         I*4        1       HOUR OF DAY
C
C        IMINDAY        I*4        1       MINUTE OF HOUR
C
C        ISECDAY        I*4        1       SECOND OF MINUTE
C
C     OUTPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        ISECWK         I*4        1       SECOND OF WEEK
C        
C
$INCLUDE:'WRDSIZ.INC'
C
      CALL HMSTSEC  ( XSECDAY, IHRDAY, IMINDAY, ISECDAY ) 
C
      ISEC   = XSECDAY
      ISECWK = IDAYWK * 86400 + ISEC
      RETURN
C 
      END 
$PAGE
      SUBROUTINE YDTTGPS (IYEAR, IDOY, SECDAY, NGPSWK, NGPSDOW, GPSSEC) 
C 
C    THIS ROUTINE WILL CONVERT YEAR, DAY OF YEAR AND SEC OF DAY
C    TO GPS WEEK NUMBER, GPS DAY OF WEEK AND GPS SEC OF WEEK. 
C 
C          THIS ROUTINE RETURNS INTEGER FORMS OF THE GPS WEEK
C     NUMBER AND GPS DAY OF WEEK, AND THE FLOATING POINT FORM
C     OF THE GPS SECOND OF WEEK.  THE INPUT TO YDTTGPS CONSISTS
C     OF INTEGER FORMS OF THE YEAR(2 OR 4 DIGIT FORM) AND DAY OF
C     YEAR, AND THE FLOATING POINT FORM OF THE SECOND OF DAY. 
C     NOTE THAT GPS WEEK 0 IS FROM JAN 6 - 12, 1980 WITH THE FIRST 
C     DAY OF THE WEEK DESIGNATED AS DAY 0.   LEAP YEARS ARE ACCOUNTED 
C     FOR IN HERE.
C 
C     INPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        IYEAR          I*4        1       YEAR(4 0R 2 DIGIT FORM) 
C
C        IDOY           I*4        1       DAY NUMBER OF YEAR 
C
C        SECDAY         REAL*8     1       SECOND OF DAY
C
C     OUTPUT:
C        NAME           TYPE      DIM      MEANING/USE
C        ----           ----      ---      -----------
C        NGPSWK         I*4        1       GPS WEEK NUMBER
C
C        NGSPDOW        I*4        1       GPS DAY OF WEEK(0=SUN,6 = SAT)
C
C        GPSSEC         REAL*8     1       GPS SECOND OF WEEK
C 
C   WRITTEN BY DSC   2 - 23 -87 
C 
C***********************************************************************
C
$INCLUDE:'WRDSIZ.INC'  
C
C+++++ MOD BY C.R. 5/11/88
C
C        SUBROUTINE NOW ACCEPTS A YEAR INPUT(IYEAR) IN A 
C        2-DIGIT OR 4-DIGIT FORM, CONVERTING A 2-DIGIT
C        INPUT TO 4 DIGITS.
C
         JYEAR = IYEAR
         IF (JYEAR.LT. 50) JYEAR = JYEAR + 2000
         IF (JYEAR.LT.100) JYEAR = JYEAR + 1900
C
C+++++
C
C
      IYRDIFF = JYEAR - 1980
      NLEAPYR = ( IYRDIFF + 3 ) / 4 
      IDAYDIF = IDOY + IYRDIFF * 365 + NLEAPYR
      IBDAY   = 6 
C
C
      NGPSWK  = ( IDAYDIF - IBDAY ) / 7 
      NGPSDOW = IDAYDIF - IBDAY - NGPSWK * 7
      GPSSEC  = NGPSDOW * 86400.0 + SECDAY 
      RETURN
      END 
$PAGE
      SUBROUTINE MDYGPS (MONTH,IDOM,IYEAR, NWEEK, NDOW ) 
C 
C         MONTH/DAY_OF_MONTH/YEAR to GPS WEEK, DAY_OF_WEEK
C 
C     INPUT:
C              MONTH     I*4       MONTH
C              IDOM      I*4       DAY OF MONTH
C              IYEAR     I*4       YEAR, 2 OR 4 DIGITS (CYCLE 1980)
C        
C     OUTPUT:
C              NWEEK     I*4       GPS WEEK NUMBER 
C              NDOW      I*4       DAY OF WEEK
C 
C    MODHIST:
C              JRC  12-00
C 
C
$INCLUDE:'WRDSIZ.INC'  
C
C         -----------------------------------------------
C
      JYEAR = IYEAR
      IF (JYEAR.LT. 80) JYEAR = JYEAR + 2000
      IF (JYEAR.LT.100) JYEAR = JYEAR + 1900
C
      CALL  MDYDOY ( MONTH,IDOM, JYEAR, IDOY )
C
      IYRDIF  = JYEAR - 1980
      NLEAP   = ( IYRDIF + 3 ) / 4 
      IDAYDF  = IDOY + IYRDIF * 365 + NLEAP
      IBDAY   = 6 
C
C
      NWEEK   = ( IDAYDF - IBDAY ) / 7 
      NDOW    = IDAYDF - IBDAY - NWEEK * 7
      RETURN
      END 
$PAGE
      SUBROUTINE GPSMDY ( NWEEK,NDOW, MONTH,NDOM,IYEAR )
C
C         CONVERT A GPS DATE TO STANDARD 
C              WEEK, DAY OF WEEK -> M,D,Y
C
C    INPUT:
C             NWEEK      I*4       GPS WEEK -- NO ERA ROLLS
C                                              0 TO  1024,1025....
C             NDOW       I*4       DAY OF WEEK 0=SUNDAY
C
C    OUTPUT:
C              MONTH     I*4       MONTH
C              NDOM      I*4       DAY OF MONTH
C              IYEAR     I*4       YEAR - 4 DIGIT
C
C    MODHIST
C         JRC  12-00
C
$INCLUDE:'WRDSIZ.INC'
C
C    -------------------------------------------------------------
C
      IDAYS    =    6+7*NWEEK  + NDOW
C
C       COUNT LEAP CYCLES ( 4*365+1 DAYS ) SINCE FEB 29, 1980
C       TO GET YEARS. 2000 IS A LEAP YEAR, SO WORKS. 
C       FOR DAY OF YEAR,  NEED THE NUMBER IN PREVIOUS YEARS
C       DON'T HAVE TO DEAL WITH FAR PAST -- IS GPS UTILITY
C
C         LEAP DAYS SINCE BEGINNING OF GPS TIME
C
      NDAYLP   =    IDAYS - 60
      NLEAP    =    1 + NDAYLP/1461
C
      NYR      =    (IDAYS - NLEAP - 1 )/365
      IDOY     =    IDAYS - NYR*365 - NLEAP
C
C         TOOK OUT 1 TOO FEW DAYS DURING LEAP YEAR - PRIOR 2/29
C
      IF (MOD(NYR,4) .EQ.0 ) THEN
           IDOY  =  IDOY + 1
           LEAPR =  IDAYS - (NLEAP - 1)*1461
           IF ( LEAPR.GT.366) IDOY = IDOY - 1
      ENDIF
C           
C
      IYEAR    =    1980  + NYR
C
      CALL   DOYMDY ( IYEAR, IDOY, MONTH, NDOM )
C
      RETURN
      END 
$PAGE
      SUBROUTINE CURGPS ( IWN, IDOW )
C
C         RETURN CURRENT WEEK AND DAY OF WEEK
C
$INCLUDE:'WRDSIZ.INC'
C
C
      INTEGER*2          IDATE ( 3 )
C
C    -----------------------------------------------------
C
C
      CALL DATE (IDATE)
C
      IYEAR = IDATE(1)
      MNTH  = IDATE(2)
      NDOM  = IDATE(3)
C
      CALL  MDYDOY ( MNTH, NDOM, IYEAR, IDOY )
C
      SOD = 0.0D0
      CALL YDTTGPS ( IYEAR, IDOY, SOD, NWK, NDOW, SOW )
C
      IWN  = NWK
      IDOW = NDOW
C
      RETURN
      END
$PAGE
      SUBROUTINE  WKERA ( IWEEK, NEWNWK, NCHG )
C
C         CKECK  GPS WEEK ERA 
C         USE CURRENT TIME AND +/- 10YEARS  (512 WEEKS )
C
C    INPUT:
C         IWEEK          I*4       WEEK NUMBER HAVE
C
C    OUTPUT:
C         NEWNWK         I*4       NEW WEEK NUMBER
C         NCHG           I*4       NUMBER OF ERAS CHANGED
C
$INCLUDE:'WRDSIZ.INC'
C
C    ---------------------------------------------------------
C    
      CALL CURGPS ( NOWWK, NDOW )
C
      NSTEP =   0
      NDIF  =   NOWWK - IWEEK
      IF ( IABS(NDIF) .LT. 512 ) GOTO 800
C
      IF ( NDIF.GT.0 )  THEN
           NSTEP = (NDIF+512)/1023 
      ELSE
           NSTEP = - ((IABS(NDIF)+512)/1023)
      ENDIF
C
800   CONTINUE
C
      NEWNWK =  IWEEK + NSTEP * 1024
      NCHG   =  NSTEP
C
      RETURN
      END
