$TITLE:'MOD JULIAN DAY ROUTINES'
      SUBROUTINE YD2MJD (IYR,IDAY, MJD) 
C
C       GIVEN INTEGER YEAR AND DAY OF YEAR
C       RETURN THE MODIFIED JULIAN DAY
C
$INCLUDE:'WRDSIZ.INC'
C 
      DATA IYRZ,MJDZ / 1973, 41682 /
C
C      CREATED 2/11/90 jrc FROM MJD
C             12 20 99 JRC CORRECT FOR 1900 .NE. LEAP YEAR
C                                      (BUT 2000 IS !)
C
C      
C     THIS ROUTINE NOW CHECKS FOR A 2-DIGIT YEAR
C     INPUT. IF THE YEAR IS INPUT IN 2 DIGITS, IT
C     IS CONVERTED TO A 4-DIGIT FORM.
C
      IYU = IYR
      IF ( IYU .LT. 50 ) IYU = IYU + 2000
      IF ( IYU .LT. 100) IYU = IYU + 1900
C
C+++++
C
      KYR = IYU - IYRZ
      IF(KYR.LT.0) GO TO 20 
C
C        FORWARD FROM REF TIME
C
      MJDI=MJDZ+365*KYR+(KYR/4)
      MJDI=MJDI+IDAY
      GOTO 900
C
C       BACKWARD FROM REF TIME
C
20    CONTINUE
      MJDI=MJDZ + 365*KYR -((IABS(KYR)+3)/4) 
      MJDI=MJDI + IDAY
      IF (IYU.LE.1900) MJDI = MJDI + 1
      GOTO 900
C
900   CONTINUE
C
      MJD  = MJDI
      RETURN
      END 
$PAGE
      SUBROUTINE MJD2YD (MJD,IYR,IDAY) 
C
C       GIVEN MJD RETURN THE YEAR AND DAY OF YEAR
C
$INCLUDE:'WRDSIZ.INC'
C 
      DATA IYRZ,MJDZ / 1973, 41682 /
C
C      CREATED 2/11/90 jrc FROM MJD
C
C      
      IDIF  =  MJD - MJDZ
C
      IDYR = IDIF / 365
      IYRU = IYRZ + IDYR
      IDY1 =  1
C
100   CONTINUE
C
      CALL  YD2MJD ( IYRU, IDY1, MJD1 )
C
      IDOY  =   MJD - MJD1 + 1
      IF ( IDOY .LE. 0 ) THEN
          IYRU = IYRU - 1
          GOTO 100
      ENDIF
C
      IF ( IDOY.LE.365 ) GOTO 900
C
      IF ( IDOY.GT.366 ) THEN
          IYRU = IYRU + 1
          GOTO 100
      ENDIF
C
C       366 CK IF LEAP YR
C
      IYR4   =  IYRU / 4
      IYR100 =  IYRU / 100
      I4CK   =  IYRU - 4 * IYR4
      I100CK =  IYRU - 100 * IYR100
C
      I4CK    = MOD(IYRU,4)
      I100CK  = MOD(IYRU,100)
      I400CK  = MOD(IYRU,400)
C
      NLY  = 0
      IF ( I4CK.EQ.0 )  NLY = 1
      IF ( I100CK.EQ.0) NLY = 0
      IF ( I400CK.EQ.0) NLY = 1
C
      IF ( NLY.NE.0 ) GOTO 900
C
CC==      IF ( I4CK.EQ.0 .AND. I100CK.NE.0 ) GOTO 900
C
      IYRU  = IYRU +1
      GOTO 100
C
900   CONTINUE
C
      IYR   = IYRU
      IDAY  = IDOY
C
      RETURN
      END 
$PAGE
      SUBROUTINE MJDGPS ( MJD, IWEEK, IDOW )
C
C          MODIFIED JULIAN DATE TO GPS WEEK, DAY OF WEEK
C
C      INPUT
C             MJD    I*4       MODIFIED JULIAN DATA 
C      OUTPUT
C             IWEEK  I*4       GPS WEEK NUMBER
C             IDOW   I*4       DAY OF WEEK ( 0 = SUNDAY ... )
C
$INCLUDE:'WRDSIZ.INC'
C
C
      CALL MJD2YD ( MJD, IYR,IDOY )
C
      IYRDIF =  IYR - 1980
      NLEAPY =  ( IYRDIF + 3 ) / 4
      IDDIF  =  IDOY + 365*IYRDIF + NLEAPY
C
      NGPSWK =  ( IDDIF - 6 ) / 7
      NDOW   =  IDDIF - 6 - 7 * NGPSWK
C
      IWEEK  =  NGPSWK
      IDOW   =  NDOW
C
      RETURN
      END
$PAGE
      SUBROUTINE GPSMJD ( IWEEK, IDOW, MJD )
C
C         GPS WEEK, DAY OF WEEK TO MODIFIED JULIAN DATE 
C
C      INPUT
C             IWEEK  I*4       GPS WEEK NUMBER
C             IDOW   I*4       DAY OF WEEK ( 0 = SUNDAY ... )
C      OUTPUT
C             MJD    I*4       MODIFIED JULIAN DATE
C
$INCLUDE:'WRDSIZ.INC'
C
C
      IDAYS  =  6 + 7 * IWEEK + IDOW
      NYR    =  IDAYS / 365
      NLEAPY =  ( NYR + 3 ) / 4
C
      IDOY   =  IDAYS - 365*NYR  - NLEAPY
      IYR    =  1980 + NYR
C
      CALL  YD2MJD ( IYR,IDOY, MJDI )
C
      MJD   = MJDI 
C
      RETURN
      END
