      PROGRAM R BFILTER
C
C       APPLY A BUTTERWORTH FILTER TO FILE OF REALS
C       UP TO 10 TH ORDER
C
$INCLUDE:'WRDSIZ.INC'
C
C
      DIMENSION  STATV ( 10 )
C
      DIMENSION  AN (21), AD (21), WORK (63)
C
      CHARACTER * 30   FNIN, FNOUT
      CHARACTER * 50   FMTIN,FMTOUT
C
C     -------------------------------------------------------------
C
C
      WRITE (*,2000 )
2000  FORMAT (//4X,'BUTTERWORTH FILTER OF VALUES - REAL VALUES '/ )
C
100   CONTINUE
C
      WRITE (*,2001)
2001  FORMAT(4X,'ENTER INPUT  FILE NAME: '\)
      READ ( *, 1001 ) FNIN
1001  FORMAT ( A )
C
      LUNIN = 1
      OPEN ( LUNIN, FILE=FNIN, STATUS='OLD', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2101 ) IOCK
2101       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 100
      ENDIF
C
110   CONTINUE
C
C
      WRITE (*,2002)
2002  FORMAT(4X,'ENTER OUTPUT FILE NAME: '\)
      READ ( *, 1002 ) FNOUT
1002  FORMAT ( A )
C
      LUNOUT = 2
      OPEN ( LUNOUT, FILE=FNOUT, STATUS='NEW', IOSTAT=IOCK )
      IF ( IOCK.NE. 0 ) THEN 
           WRITE (*,2102 ) IOCK
2102       FORMAT ( //4X,'OPEN ERROR ',I10,/)
           GOTO 110
      ENDIF
C
120   CONTINUE
C
      WRITE (*,2003 )
2003  FORMAT ( /4X,'ENTER FORMAT FOR READ:  '\ )
      READ (*,1003 ) FMTIN
      WRITE (*,2013 )
2013  FORMAT (  4X,'ENTER FORMAT FOR WRITE: '\ )
      READ (*,1003 ) FMTOUT
1003  FORMAT ( A )
C
130   CONTINUE
C
C        GET PARAMETERS  
C
      WRITE (*, 2004)
2004  FORMAT (/4X,' ENTER SAMPLE FREQ (FS), '/
     $         4X,'       BAND LOW (FL) AND HIGH (FH) FREQ '/
     $         4X,'       ( FL=0 FOR LOWPASS,  FH .LT. FS/2 ) '/
     $        /4X,'        FS,FL,FH :  '\ )
C
      READ (*,* ) FS, FL, FH
C
C         DATA ACCEPTABLITY CHECKS
C
      IF ( FS.LE.0.0 ) GOTO 130
      FNQ  =  FS/ 2.0
      IF ( FH.GE.FNQ ) GOTO 130
      IF ( FL.LT.0.0 ) FL = 0.0
C
140   CONTINUE
C
      WRITE (*,2005)
2005  FORMAT( /4X,' ENTER ORDER OF FILTER (.LE.10)  : '\)
C
      READ (*,*) KORDER
C
      IF ( KORDER.LE.0 ) GOTO 140
      IF ( KORDER.GT.10) GOTO 140
C
C         MAKE THE FILTER  -  COMPUTER PARAMETERS
C
      G    = 0.0D0
      DEL  = 0.0D0
C
      DO 190 I=1,21
        AN(I)  = 0.0D0
        AD(I)  = 0.0D0
190   CONTINUE
C
C
      CALL MAKFIL ( FL,FH,FS, G,DEL,KORDER,
     $              NCOEF, AN, AD, IERR )
C
       IF ( IERR.NE.0 ) THEN
            WRITE ( *, 2091 ) IERR
2091        FORMAT (/4X,'FILTER COEF. COMPUTATION ERROR : ',I8//)
            GOTO  130
       ENDIF
C
       WRITE (*,2009 ) NCOEF, ( IO, AN(IO), AD(IO), IO=1, NCOEF )
2009  FORMAT ( /10X,I4,'  COEF. IN FILTER '//4X,'  I  ',10X,'AN(I)',
     $                 16X,'AD(I) '/(4X,I3,2D20.10))
C
C
       NPTS  = 0
       IRSUM = 0  
       CALL STATL ( DUM,DUM, STATV )
C
       ICLR  =  1
C
C     -----------------------------------------------------------
C
200   CONTINUE
C
      READ ( LUNIN, FMTIN,END=800,ERR=700 ) RN
C
      ROUT  = RN
      CALL FILTER ( 1, ROUT, NCOEF, ICLR, AN,AD, WORK )
      ICLR  = 0
C
      WRITE (LUNOUT, FMTOUT ) ROUT
C
      NPTS  = NPTS + 1
C
      CALL STATXY ( RN, ROUT, STATV )
C
      GOTO 200
C
C    ------------------------------------------------------------
C
C           ERROR CONDITION
C
700   CONTINUE
C
      WRITE (*,2110 ) NPTS + 1
2110  FORMAT ( //4X,'ERROR ON READ ',I5/)
C
      GOTO 200
C
C           END OF FILE
C
800   CONTINUE
C
900   CONTINUE
C
C
      CALL STATR ( DUM, DUM, STATV )
C
      AVGIN    =  STATV ( 2 )
      AVGOUT   =  STATV ( 3 )
      SDIN     =  STATV ( 4 )
      SDOUT    =  STATV ( 5 )
C
      WRITE (*, 2011 ) NPTS,AVGIN,SDIN,AVGOUT,SDOUT
2011  FORMAT ( /4X,I6,'  POINTS '/
     $          4X,6X,'INPUT   AVG ',F18.6,3X,'SD',F18.6/
     $          4X,6X,'OUTPUT      ',F18.6,3X,'  ',F18.6/)
C
      CLOSE ( LUNIN )
      CLOSE ( LUNOUT )
C
      END
