      SUBROUTINE SORTI ( N, IA )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     IA = ARRAY ( REAL * 4 )
C
      DIMENSION IA ( N )
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALOCATION--PHASE
C
          L    = L - 1
          IIA  = IA(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          IIA    =  IA(IR)
          IA(IR) =  IA(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. IA(J).LT.IA(J+1) ) J = J + 1
C
           IF ( IIA.GE.IA(J) ) GOTO 220
C 
C           DEMOTE IIA
C
                IA(I)  = IA(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT IIA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT IIA IN PROPER SLOT
C
      IA(I)    = IIA
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      IA(1)  = IIA
C
990   CONTINUE
      RETURN
      END
      SUBROUTINE RSRTX ( N, RA )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     RA = ARRAY ( REAL * 4 )
C
      DIMENSION RA ( N )
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALOCATION--PHASE
C
          L    = L - 1
          RRA  = RA(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          RRA    =  RA(IR)
          RA(IR) =  RA(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. RA(J).LT.RA(J+1) ) J = J + 1
C
           IF ( RRA.GE.RA(J) ) GOTO 220
C 
C           DEMOTE RRA
C
                RA(I)  = RA(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT RRA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT RRA IN PROPER SLOT
C
      RA(I)    = RRA
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      RA(1)  = RRA
C
990   CONTINUE
      RETURN
      END
      SUBROUTINE SORTIK ( N, IA, IX )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     IA = ARRAY ( REAL * 4 )
C     IX = ARRAY TO CO-SORT ,, USE IA AS KEY
C
      DIMENSION IA ( N ),  IX( N )
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALLOCATION--PHASE
C
          L    = L - 1
          IIA  = IA(L)
          IIX  = IX(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          IIA    =  IA(IR)
          IIX    =  IX(IR)
          IA(IR) =  IA(1)
          IX(IR) =  IX(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. IA(J).LT.IA(J+1) ) J = J + 1
C
           IF ( IIA.GE.IA(J) ) GOTO 220
C 
C           DEMOTE IIA
C
                IA(I)  = IA(J)
                IX(I)  = IX(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT IIA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT IIA IN PROPER SLOT
C
      IA(I)    = IIA
      IX(I)    = IIX
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      IA(1)  = IIA
      IX(1)  = IIX
C
990   CONTINUE
      RETURN
      END
      SUBROUTINE RSRTXY ( N, RA, RB )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     RA = ARRAY ( REAL * 4 )
C     RB = ARRAY TO CO-SORT ,, USE RA AS KEY
C
      DIMENSION RA ( N ),  RB( N )
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALLOCATION--PHASE
C
          L    = L - 1
          RRA  = RA(L)
          RRB  = RB(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          RRA    =  RA(IR)
          RRB    =  RB(IR)
          RA(IR) =  RA(1)
          RB(IR) =  RB(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. RA(J).LT.RA(J+1) ) J = J + 1
C
           IF ( RRA.GE.RA(J) ) GOTO 220
C 
C           DEMOTE RRA
C
                RA(I)  = RA(J)
                RB(I)  = RB(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT RRA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT RRA IN PROPER SLOT
C
      RA(I)    = RRA
      RB(I)    = RRB
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      RA(1)  = RRA
      RB(1)  = RRB
C
990   CONTINUE
      RETURN
      END
      SUBROUTINE RSRTXI ( N, RA, IX )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     RA = ARRAY ( REAL * 4 )
C     IX = ARRAY TO CO-SORT ,, USE RA AS KEY
C
      DIMENSION RA ( N ),  IX( N )
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALLOCATION--PHASE
C
          L    = L - 1
          RRA  = RA(L)
          IIX  = IX(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          RRA    =  RA(IR)
          IIX    =  IX(IR)
          RA(IR) =  RA(1)
          IX(IR) =  IX(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. RA(J).LT.RA(J+1) ) J = J + 1
C
           IF ( RRA.GE.RA(J) ) GOTO 220
C 
C           DEMOTE RRA
C
                RA(I)  = RA(J)
                IX(I)  = IX(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT RRA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT RRA IN PROPER SLOT
C
      RA(I)    = RRA
      IX(I)    = IIX
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      RA(1)  = RRA
      IX(1)  = IIX
C
990   CONTINUE
      RETURN
      END
      SUBROUTINE RSRTXA ( N,M, RA, RB )
C
C   MODHIST:
C              11-1-95  FROM SORTXY - JRC
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     RA = ARRAY ( REAL * 4 )
C     RB(M,N)  = ARRAY TO CO-SORT ,, USE RA AS KEY
C
C
C -----------------------------------------------------------------
C
      DIMENSION RA ( N ),  RB( * )
C
C    TEMP STORAGE FOR RB ELEMENT M LONG
C
      DIMENSION   RRB(256)
C
C         ----------------------------------------------------
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
      IF (M .LE. 1 .OR. M.GT. 256 ) GOTO 990
C
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALLOCATION--PHASE
C
          L    = L - 1
          RRA  = RA(L)
C==          RRB  = RB(L)
          IXB  = 1 + (L-1)*M
          CALL MOVRA ( M, RB(IXB), RRB )
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          RRA    =  RA(IR)
C==          RRB    =  RB(IR)
          IXB  = 1 + (IR-1)*M
          CALL MOVRA ( M, RB(IXB), RRB )
          RA(IR) =  RA(1)
C ==          RB(IR) =  RB(1)
          IXB1 = 1
          IXB2 = 1 + (IR-1)*M
          CALL MOVRA ( M, RB(IXB1), RB(IXB2) )
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. RA(J).LT.RA(J+1) ) J = J + 1
C
           IF ( RRA.GE.RA(J) ) GOTO 220
C 
C           DEMOTE RRA
C
                RA(I)  = RA(J)
C==                RB(I)  = RB(J)
                IXB1 = 1 + (J-1)*M
                IXB2 = 1 + (I-1)*M
                CALL MOVRA ( M, RB(IXB1), RB(IXB2) )
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT RRA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT RRA IN PROPER SLOT
C
      RA(I)    = RRA
C==      RB(I)    = RRB
      IXB  = 1 + (I-1)*M
      CALL MOVRA ( M, RRB(1), RB(IXB) )
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      RA(1)  = RRA
C==      RB(1)  = RRB
      IXB  = 1
      CALL MOVRA ( M, RRB, RB(IXB) )
C
990   CONTINUE
      RETURN
      END
