      SUBROUTINE XISORT ( N, RA, IX )
C
C    HEAP SORT -- ALGORITHM AND CODE OUTLINE IN P.F.T.V. PG 231
C                 FORTRAN 4/5 COMPATIBLE VERSION 
C                 ( CHANGED ALL IF-THEN-ELSE 'S )
C          ================
C    ====  R*8, I*4 VERSION =====
C          ================
C
$INCLUDE:'WRDSIZ.INC'
C
C
C     IN PLACE SORT OF REAL ARRAY
C     N  = NUMBER OF ELEMENTS IN ARRAY  ( I*4 BY DEFAULT )
C     RA = ARRAY ( REAL * 4 )
C     IX = ARRAY TO CO-SORT ,, USE RA AS KEY
C
      DIMENSION RA ( N ),  IX( N )
C
C         ------------------------------------------------
C
C
C   CHECK FOR N GREATER THAN 1
C
      IF (N .LE. 1) GOTO 990
C
C   L = HIRING INDEX
C   IR = PROMOTION INDEX
C
      L   = N/2 + 1
      IR  = N
C
C  -----------------   TOP OF LOOP   --------------------------
C
100   CONTINUE
C
C
      IF ( L .LE. 1 ) GOTO 110
C
C         IN HIRING--ALLOCATION--PHASE
C
          L    = L - 1
          RRA  = RA(L)
          IIX  = IX(L)
          GOTO 120
C
110   CONTINUE
C
C         RETIREMENT AND PROMOTION PHASE
C
          RRA    =  RA(IR)
          IIX    =  IX(IR)
          RA(IR) =  RA(1)
          IX(IR) =  IX(1)
C
          IR     =  IR - 1
C
C      CK IF ALL DONE
C 
          IF ( IR .EQ. 1 ) GOTO 900
C
120   CONTINUE
C
C   END OF PHASE DEPENDENT CODE
C
C     NOW FOR DOWN SHIFT OF DATA 
C
      I  =  L
      J  =  L + L
C
200   CONTINUE
C
      IF ( J .GT. IR ) GOTO 280
C
C     CK IF BELOW TO BE PROMOTED UP
C
           IF ( J.LT.IR .AND. RA(J).LT.RA(J+1) ) J = J + 1
C
           IF ( RRA.GE.RA(J) ) GOTO 220
C 
C           DEMOTE RRA
C
                RA(I)  = RA(J)
                IX(I)  = IX(J)
                I      = J
                J      = J + J
                GOTO 230
C
220        CONTINUE
C
C          AT RRA'S LEVEL. SET J TO TERMINATE SHIFT DOWN
C
                J   =  IR + 1
C
230        CONTINUE
C
           GOTO 200
C
280   CONTINUE 
C
C        PUT RRA IN PROPER SLOT
C
      RA(I)    = RRA
      IX(I)    = IIX
C
      GOTO 100
C
C    EXIT
C
900   CONTINUE
C
      RA(1)  = RRA
      IX(1)  = IIX
C
990   CONTINUE
      RETURN
      END
